// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef _FML_H_
#define _FML_H_

typedef enum
{
	ML_VECTOR_PRINT,
	ML_VECTOR_MODULE,
	ML_VECTOR_NORMAL,
	ML_VECTOR_CROSS_PRODUCT,
	ML_VECTOR_SCALAR_PRODUCT,
	ML_MULT_VECTOR_AND_SCALAR,

	ML_MATRIX_PRINT,
	ML_MATRIX_DETERMINANT,
	ML_MATRIX_TRANSPOSE,
	ML_ADJOINT,
	ML_MATRIX_ADJOINT,
	ML_MATRIX_INVERSE,
	ML_MULT_MATRIX_AND_SCALAR,
	ML_ADD_MATRIX_AND_MATRIX,
	ML_MULT_MATRIX_AND_MATRIX
} MLenum;

typedef enum { ML_TRUE = 1, ML_FALSE = !ML_TRUE } MLboolean;
typedef double MLdouble;
typedef float MLfloat;
typedef int MLint;
typedef unsigned int MLuint;
typedef int MLsizei;
typedef void MLvoid;

void
mlVectorfv(MLenum pname, MLsizei cols, const MLfloat *param, MLfloat *result);

void
mlVector2f(MLenum pname, MLsizei cols, const MLfloat *param1, MLfloat param2, MLfloat *result);

void
mlVector2fv(MLenum pname, MLsizei cols, const MLfloat *param1, const MLfloat *param2, MLfloat *result);

void
mlMatrix2f(MLenum pname, MLsizei rows, MLsizei cols, const MLfloat *param1, MLfloat param2, MLfloat *result);

void
mlMatrix3f(MLenum pname, MLsizei rows, MLsizei cols, const MLfloat *param1, MLfloat param2, MLfloat param3, MLfloat *result);

void
mlVector2fv(MLenum pname, MLsizei cols, const MLfloat *param1, const MLfloat *param2, MLfloat *result);

void
mlMatrixfv(MLenum pname, MLsizei rows, MLsizei cols, const MLfloat *param, MLfloat *result);

void
mlMatrix2fv(MLenum pname, MLsizei rows1, MLsizei cols1, const MLfloat *param1, MLsizei rows2, MLsizei cols2, const MLfloat *param2, MLfloat *result);

#endif

